/*

  filesize - print the size of a given directory or file

  Copyright 2001 by MSDatec

    This code is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This code is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "version.h"
#include "copyright.h"



void help() {
  printf("Returns the size of a file.\n"\
         "\n"\
         "Usage: "PROGRAMNAME" [-hV] <filename>\n"\
         "  -h: show this help\n"\
         "  -V: print version\n"\
         "\n"\
         "Report bugs to <ms@msdatec.de>\n");

}


int main(int argc, char **argvec) {
  struct stat stbuf;
  char *filename;
  char c;

  while ((c = getopt(argc, argvec, "hV")) != EOF) {
    switch (c) {
      case 'h':
        help();
        exit(0);
        break;
      case 'V':
        printf(COPYRIGHT);
        exit(0);
        break;
      default:
        printf("(use -h for help)\n");
        exit(1);
        break;
    }

  }
  if (argc != 2) {
    fprintf(stderr, "%s: exact one file name must be given\n", argvec[0]);
    exit(1);
  }
  filename = argvec[1];

  if (stat(filename, &stbuf) == -1) {
    fprintf(stderr, "%s: can't access %s\n", argvec[0], filename);
    exit(1);
    }
  else {
    printf("%ld", stbuf.st_size);
    }
  exit(0);
}
